#include "prismoids.h"
#include "pthread.h"

#include <stdio.h>
//#include <sys/types.h>
//#include <sys/stat.h>
//#include <fcntl.h>
#include <unistd.h>
#include <signal.h>
#include <errno.h>
#include <string.h>

#define MAX_BSS 16	
#define MAXLEN 80

void * printbsslist (void *);
void kdinthandler (char);
char * switchssid (void);
int chkiwconfig (char *);
int chkifconfig (void);

pid_t th1bsslist;

struct obj_bsslist *bsslist;
struct obj_bss *lbss;
int lock = 0;
char *if_name = "eth1";
char curr_ssid[80], prev_ssid[80];
char *l = prev_ssid;

int
main (void) 
{
	// start display thread
	int ret, c;
	pthread_t *threadp;
	
	prismoid_open();

	if ( (ret = pthread_create (threadp, NULL, printbsslist, NULL)) != 0 )
	{
		perror ("Failed to start thread printbsslist");
		exit (1);
	}
	
	system ("stty -icanon -echo");

	while ( (c = getchar ()) != 'q' ) 
		kdinthandler (c);

	// kill kill kill
	printf ("kill all\n");
	if ( (ret = kill (th1bsslist, 15)) == -1 )
	{
		perror ("Failed to kill threads\n");
		exit (1);
	}
	
	prismoid_close();

	ret = pthread_join (*threadp, NULL);

	system ("stty icanon echo");

	return 0;
}

void *
printbsslist (void * args)
{
	printf ("in thread\n");
	th1bsslist = getpid ();

	unsigned char data[1024];
	unsigned int oid = 0x1c000043;

	int i, j, ret = 0;

	while (1) 
	{
		system ("clear");

		if ( (ret = get_prismoid (if_name, oid, (void *)&data, 4+1+ MAX_BSS* sizeof (struct obj_bss))) == 0)
		{
	            bsslist = (struct obj_bsslist *) data;
        	    lbss = (struct obj_bss *) bsslist->bsslist;            
        
		    printf ("nr = %d\n", bsslist->nr);
	            printf( "Nr\tMAC Address\t\tf[MHz]\tRates\tSSID\n" );
        	    for ( j = 0; j < bsslist->nr; j++, lbss++ ) {
	                printf( "%2.2i\t", j+1 );
        	        for ( i = 0; i < 5; i++ ) {
	                    printf( "%2.2X:", (unsigned char)lbss->address[i] );
        	        }
	                printf( "%2.2X\t", (unsigned char)lbss->address[5] );
        	        printf( "%2.2i\t",  lbss->channel );
        		printf( "%d\t", lbss->basic_rates);
        		printf( "%s\t\n", &lbss->ssid[1] );
			//printf( "%c\t", lbss->quality);
		    }

			sleep (5);
		
		}
	
		else exit (0);
	}
}

void 
kdinthandler (char opt)
{
	int ret;
	char * ssid;
	
	switch (opt) 
	{
		case 's':
			lock = 1;
			ssid = switchssid ();
			printf ("ssid = %s\n", ssid);
			if ( (ret = chkiwconfig(++ssid)) == 1)  //skip empty char at start of string
			{
				printf ("ssid set\n");

				// associate with ap - get ip_addr
				if ( (ret = system ("pump -i eth1"))  != -1 )
				{
					// check ifconfig
					if ( (ret = chkifconfig()) == 1 )
					{
						printf ("ifconfig set\n");
						//l = ssid; // update last_best conn	
					}
					else ;
				}
				else
				{
				}
				
			}
			else printf ("ssid not set.\n");
			
			lock = 0;
			break;
		case '\n':
			break;
		default:
			printf ("what do you want %c to do\n", opt);
			break;
	}
}

char *
switchssid (void)
{

	struct obj_bss *temp = (void *)malloc (sizeof (struct obj_bss));	
	unsigned int oid = 10000002;
	
	system ("stty icanon echo");

	int nr, ret = 0;
	
	printf ("switch to: ");
	scanf ("%d", &nr);

	nr--;
	system ("stty -icanon -echo");
	
	temp = bsslist->bsslist;
	temp+=nr;

	printf( "is %s what ur tryin to connect?\n", &temp->ssid );

	// call setoid
	ret = set_prismoid (if_name, 10000002, temp->ssid, sizeof (struct obj_ssid));
	
	sleep (3);
	return temp->ssid;

}

int
chkiwconfig (char *ssid)
{
	printf ("ifconfig\n");
	int set = 0;
	
	FILE *fp;	
	char one_line[MAXLEN + 1];
	     
	fp = popen ("/sbin/iwconfig eth1 2>/dev/null", "r");

     	/* read line by line from the ifconfig pipe */
     	while (fgets(one_line, MAXLEN, fp) != NULL) 
	{
		if (strstr(one_line, ssid) != NULL) 
		{
	       		set = 1;
	       		break;     
	  	}
     	}

     	pclose (fp);

	return set;

}

int
chkifconfig (void)
{
	int set = 0;

	FILE *fp;	
	char one_line[MAXLEN + 1];
	     
	fp = popen ("/sbin/ifconfig eth1 2>/dev/null", "r");

     	/* read line by line from the ifconfig pipe */
     	while (fgets(one_line, MAXLEN, fp) != NULL) 
	{
		if (strstr(one_line, "inet addr") != NULL) 
		{
	       		set = 1;
	       		break;     
	  	}
     	}

     	pclose (fp);

	return set;
}

